/* infoticker.m (2024-01-01)

Shows the info ticker in place of the song ticker when the seeker is dragged
or the volume is changed.

Code extracted from Winamp Modern’s seek.m and mute.m */

#include "lib/std.mi"

Global GuiObject SongTicker;
Global Text InfoTicker;
Global Timer SongTimer;
Global Slider Seeker;
Global Int Seeking;

Function updateVolume(int v);

System.onScriptLoaded() {
  Group ScriptGrp = getScriptGroup();

  Seeker = ScriptGrp.findObject("Seeker");
  SongTicker = ScriptGrp.findObject("SongTicker");
  InfoTicker = ScriptGrp.findObject("InfoTicker");

  SongTicker.show();
  InfoTicker.hide();

  SongTimer = new Timer;
  SongTimer.setDelay(1000);
}

SongTimer.onTimer() {
  SongTicker.show();
  InfoTicker.hide();
  SongTimer.stop();
}

Seeker.onLeftButtonDown(int x, int y) {
  seeking = 1;
}

Seeker.onLeftButtonUp(int x, int y) {
  seeking = 0;
  SongTimer.start();
  SongTicker.show();
  InfoTicker.hide();
}

Seeker.onSetPosition(int per255age) {
  if (seeking) {
    Int seekage;
    seekage = per255age;
    if (getPlayItemLength() > 0) {
      Float floatElapsed = getPlayItemLength() * seekage/255;
      String seekPercentage;
      seekPercentage = integerToString(seekage*100/255);
      SongTimer.start();
      SongTicker.hide();
      InfoTicker.show();
      if (getPlayItemLength() < 3600000) {
        InfoTicker.setText(integerToTime(floatElapsed) + " / " + integerToTime(getPlayItemLength()) + "   " + seekPercentage + "%");
      }
      else {
        InfoTicker.setText(integerToLongTime(floatElapsed) + " / " + integerToLongTime(getPlayItemLength()) + "  " + seekPercentage + "%");
      }
    }
  }
}

Seeker.onSetFinalPosition(int p) {
  SongTimer.start();
  SongTicker.show();
  InfoTicker.hide();
}

System.onvolumechanged(int newvol) {
  SongTimer.start();
  SongTicker.hide();
  InfoTicker.show();
  InfoTicker.setText("Volume" + ": " + integerToString(newvol/2.55) + "%");
}

System.onScriptUnloading() {
  delete SongTimer;
}
