/* volumeFill.m by Ariszlo <ariszlo@gmail.com> 2023-12-26

Fills the area below the thumb in a vertical volume slider.

USING THIS SCRIPT

Add a "Volume Fill" layer before the volume slider like this:

  <Layer
    id="Volume Fill"
    x="?" w="?"
    image="?"
  />

Then add the tag calling this script:

  <script id="volumefill" file="scripts/volumefill.maki"/>
*/

#include "lib/std.mi"

Global Slider volumeSlider;
Global Layer volumeFill;
Global Int fullheight, fulltop;

System.onScriptLoaded() { 
  Group ScriptGrp = getScriptGroup();
  volumeSlider = ScriptGrp.getObject("Volume");
  volumeFill = ScriptGrp.findObject("Volume Fill");
  fullheight = stringtointeger(volumeSlider.getXmlParam("h"));
  fulltop = stringtointeger(volumeSlider.getXmlParam("y"));
  String loadheight = integertostring((getVolume()/255) * fullheight);
  String loadtop = integertostring(fulltop + fullheight - (getVolume()/255)*fullheight); 
  volumeFill.setXmlParam("h",loadheight);
  volumeFill.setXmlParam("y",loadtop);
}

System.onvolumechanged(int newvol) {
  String newheight = integertostring((newvol/255) * fullheight);
  String newtop = integertostring(fulltop + fullheight - (newvol/255)*fullheight); 
  volumeFill.setXmlParam("h",newheight);
  volumeFill.setXmlParam("y",newtop);
}
